<?php

namespace itguild\forms;

use itguild\forms\builders\SelectBuilder;
use itguild\forms\debug\Debug;
use itguild\forms\inputs\BaseInput;
use itguild\forms\inputs\Select;

class ActiveForm
{
    private BaseInput $fieldObject;

    public function field($class, string $name, array $params = [])
    {
        if ($class === Select::class){
            $this->fieldObject = SelectBuilder::build($name, $params);
        }
        else {
            $this->fieldObject = new $class($name, $params);
        }

        return $this;
    }

    public function setLabel(string $title): self
    {
        $this->fieldObject->setLabel($title);

        return $this;
    }

    public function setOptions(array $options): self
    {
        $this->fieldObject->setOptions($options);

        return $this;
    }

    public function render()
    {
        $this->fieldObject->create();
        $this->fieldObject->render();
    }

}