<?php

namespace itguild\forms\inputs;
use itguild\forms\traits\CreateOption;
use itguild\forms\traits\CreateParams;
use itguild\forms\inputs\BaseInput;
class Radio extends BaseInput
{
    use CreateParams;
    use CreateOption;
    private $name;
    private $paramsArray;
    private $options = [];
    private $value;
    private bool $hasLabel = false;
    private string $labelTitle = '';

    public function __construct(string $name, array $paramsArray = [])
    {
        $this->name = $name;
        $this->paramsArray = $paramsArray;
    }

    /**
     * @return $this
     */
    public function create(): self
    {
        $paramsString = $this->createParams($this->paramsArray);
        $optionsString = $this->createOption($this->options, $this->value);
        $this->html = "<input name='$this->name' type='radio' $paramsString>$optionsString";
        if($this->hasLabel == true) {
            $this->html = "<label>$this->labelTitle</label> $this->html";
        }

        return $this;
    }

    /**
     * @param string $name
     * @param array $paramsArray
     * @return void
     */
    public static function build(string $name, array $paramsArray = []): void
    {
        $label = new self($name, $paramsArray);
        $label->create()->render();
    }

    /**
     * @param string $title
     * @return $this
     */
    public function setLabel(string $title): self
    {
        $this->hasLabel = true;
        $this->labelTitle = $title;

        return $this;
    }

    /**
     * @param $options
     * @return $this
     */
    public function setOptions($options)
    {
        $this->options = array_merge($options, $this->options);
        return $this;
    }
}